Subject: [PATCH v2 2/4] dmaengine: Add STM32 DMA driver

From: [email-masked] (Daniel Thompson)
Date: Wed, 14 Oct 2015 15:24:13 +0100

On 14/10/15 14:41, M'boumba Cedric Madianga wrote:
> 2015-10-14 15:29 GMT+02:00 Daniel Thompson <[email-masked]>:
>> On 14/10/15 14:17, M'boumba Cedric Madianga wrote:
>>>
>>> Hi Daniel,
>>>
>>>>>> +
>>>>>> +static int stm32_dma_remove(struct platform_device *pdev)
>>>>>> +{
>>>>>> +       struct stm32_dma_device *dmadev = platform_get_drvdata(pdev);
>>>>>> +
>>>>>> +       of_dma_controller_free(pdev->dev.of_node);
>>>>>> +
>>>>>> +       dma_async_device_unregister(&dmadev->ddev);
>>>>>> +
>>>>>> +       clk_disable_unprepare(dmadev->clk);
>>>>>
>>>>>
>>>>>
>>>>> What is the purpose of disabling/unpreparing the clock here?
>>>>> stm32_dma_alloc_chan_resources() and stm32_dma_free_chan_resources()
>>>>> should
>>>>> pair up and the clock should already be stopped.
>>>
>>>
>>> stm32_dma_remove() could be called during an on-going transfer during
>>> module unload.
>>> So in that case, it seems that disabling/unpreparing the clock is needed.
>>
>>
>> Really?
>>
>> I think we need to be sure any on-going transfers are stopped.
>>
>> There are multiple reasons for this, not least the risk of executing a
>> callback that has been freed, but the one related to my point is that a
>> single clk_disable_unprepare() will remain broken because if you don't know
>> that the transfers have stopped then you don't know how many on-going
>> transfers there are.
>
> In the next version, I am going to stop the DMA, free all interrupts
> and kill tasklet in stm32_dma_remove.
> In that way, all on-going transfers will be lost as we don't have to
> wait the end of remaining transfer in order to execute this function
> as quickly as possible.

Hmnnn...

The dmaengine framework will WARN_ONCE() if an dmaengine is removed 
whilst it is active and also works hard to ensure dmaengine modules are 
not removed whilst there are active drivers using the framework.

How do we get into this function whilst there is still an active DMA 
channels?

> But even with this improvement, I think I have to disable the clock here.

As above, I think the dmaengine framework work to protect you from this 
sort problem. However even if I am wrong about that then unconditionally 
calling clk_disable_unprepare() can not be used to reliably manage the 
clocks. You don't know what the counts are!

Daniel.